%%Homework 2 m-file
% Author: Ben Griffy
% Date: Original: April 2021, Current: Feb. 2023

clear all
close all
clc



%% Functions
A = [0.9 0.1 0.0;
    0.5 0.45 0.05;
    0.1 0.0 0.9];

x0 = [0.55 0.05 0.4];

xt0 = x0;
xt1 = zeros(size(x0));


% part d
for t = 1:1000
    xt1 = xt0*A;
    xt0 = xt1;
end

fprintf('The stationary distribution is %f,%f,%f',xt1)

xt0 = unifrnd(0,1,[1,3]);
xt0 = xt0./sum(xt0);
xt1 = repmat(zeros(size(x0)),1000,1);


% part e
for t = 1:1000
    xt1(t,:) = xt0*A;
    xt0 = xt1(t,:);
end


FormatOpts = struct('GridLineStyle', '--'     , ...
                    'Box'         , 'off'     , ...
                    'TickDir'     , 'out'     , ...
                    'TickLength'  , [.02 .02] , ...
                    'XMinorTick'  , 'on'      , ...
                    'YMinorTick'  , 'on'      , ...
                    'XGrid'       , 'on'      , ...
                    'YGrid'       , 'on'      , ...
                    'XColor'      , [.3 .3 .3], ...
                    'YColor'      , [.3 .3 .3], ...
                    'LineWidth'   , 1         , ...
                    'LW'          , 2         , ...
                    'LS'          , []        , ...
                    'PaperPosition', [0,0,4,4]);


f01 = figure('name','KeyFig');
p1 = plot(1:1000,xt1(:,1),'color','g');
hold on;
p2 = plot(1:1000,xt1(:,2),'color','r');
p3 = plot(1:1000,xt1(:,3),'color','b');
xlabel('Time');
ylabel('Share');
legend([p1,p2,p3],'Emp','Unemp','Non-part');
set(gca, ...
    'GridLineStyle'         , FormatOpts.GridLineStyle     , ...
    'Box'         , FormatOpts.Box     , ...
    'TickDir'     , FormatOpts.TickDir     , ...
    'TickLength'  , FormatOpts.TickLength , ...
    'XMinorTick'  , FormatOpts.XMinorTick      , ...
    'YMinorTick'  , FormatOpts.YMinorTick      , ...
    'XGrid'       , FormatOpts.XGrid      , ...
    'YGrid'       , FormatOpts.YGrid      , ...
    'XColor'      , FormatOpts.XColor, ...
    'YColor'      , FormatOpts.YColor, ...
    'LineWidth'   , FormatOpts.LineWidth);
figfile = fullfile(pwd,'simulation1');
saveas(gcf,figfile,'png');



xt0 = unifrnd(0,1,[1,3]);
xt0 = xt0./sum(xt0);
xt1 = repmat(zeros(size(x0)),1000,1);


% part e
for t = 1:1000
    xt1(t,:) = xt0*A;
    xt0 = xt1(t,:);
end


FormatOpts = struct('GridLineStyle', '--'     , ...
                    'Box'         , 'off'     , ...
                    'TickDir'     , 'out'     , ...
                    'TickLength'  , [.02 .02] , ...
                    'XMinorTick'  , 'on'      , ...
                    'YMinorTick'  , 'on'      , ...
                    'XGrid'       , 'on'      , ...
                    'YGrid'       , 'on'      , ...
                    'XColor'      , [.3 .3 .3], ...
                    'YColor'      , [.3 .3 .3], ...
                    'LineWidth'   , 1         , ...
                    'LW'          , 2         , ...
                    'LS'          , []        , ...
                    'PaperPosition', [0,0,4,4]);


f01 = figure('name','KeyFig');
p1 = plot(1:1000,xt1(:,1),'color','g');
hold on;
p2 = plot(1:1000,xt1(:,2),'color','r');
p3 = plot(1:1000,xt1(:,3),'color','b');
xlabel('Time');
ylabel('Share');
legend([p1,p2,p3],'Emp','Unemp','Non-part');
set(gca, ...
    'GridLineStyle'         , FormatOpts.GridLineStyle     , ...
    'Box'         , FormatOpts.Box     , ...
    'TickDir'     , FormatOpts.TickDir     , ...
    'TickLength'  , FormatOpts.TickLength , ...
    'XMinorTick'  , FormatOpts.XMinorTick      , ...
    'YMinorTick'  , FormatOpts.YMinorTick      , ...
    'XGrid'       , FormatOpts.XGrid      , ...
    'YGrid'       , FormatOpts.YGrid      , ...
    'XColor'      , FormatOpts.XColor, ...
    'YColor'      , FormatOpts.YColor, ...
    'LineWidth'   , FormatOpts.LineWidth);
figfile = fullfile(pwd,'simulation2');
saveas(gcf,figfile,'png');
